#define F_CPU 16000000

#include <util/delay.h>
#include <stdint.h>
#include <avr/io.h>
#include <avr/interrupt.h>


//Initialize Cube data
uint16_t cube[5][5][5] = {0};
//i think it is z, x, y, with z going up, y going front to back, and x going left to right
//while looking at blinky head on



uint16_t adc_read(uint8_t ch)
{
    // select the corresponding channel 0~7
    // ANDing with '7' will always keep the value
    // of 'ch' between 0 and 7
    ch &= 0b00000111;  // AND operation with 7
    ADMUX = (ADMUX & 0xF8)|ch;     // clears the bottom 3 bits before ORing

    //MODIFICATION
    //stop admux from reading from register pins
    //either mask, or simple logic

    //do not read PC0 & PC5
    //read only PC1, PC2, PC3, PC4
    
    //0001, 0010, 0011, 0100

    //oh, you know what? i can just only set it to read those when i call the function
    //only tell it to adc_read(1-4)


    // start single conversion
    // write '1' to ADSC
    ADCSRA |= (1<<ADSC);
  
    // wait for conversion to complete
    // ADSC becomes '0' again
    // till then, run loop continuously
    while(ADCSRA & (1<<ADSC));
  
    return (ADC);
}



void Update_Cube() {

 
  for (uint8_t g = 0; g < 4; g++) {

  
  }

    

void Update_gsData() {
 
  uint8_t j = 0;
 
  for (int l = 0; l < 5; l++) {

  for (int t = 0; t < 46; t++) {

    uint16_t y = columns[l][j];//4095;//0b0000111111111111;
    uint16_t n = columns[l][j + 1];//255;

    gsData[l][t] = (y >> 4);//0b11111111;
    gsData[l][t+1] = (y << 4)|(n >> 8); //(y << 0);//0b11111111;
    gsData[l][t+2] = n; //(y >> 6);//0b00111111;

    t = t + 2;
    j = j + 2;

}
  
  j = 0;
  }



  


}


ISR(TIMER0_COMPA_vect) {


		for (uint8_t i = 0; i < 48; i++) {
		  SPDR = gsData[layer][i];
		  while (!(SPSR & (1 << SPIF)));
		}
	
		//pulse XLAT
		PORTB |= (1 << PORTB1)|(1 << PORTB2); //XLAT HIGH & BLANK HIGH
		PORTB = (0 << PORTB1); //XLAT LOW


		if(layer == 0) {

		  PORTD = (0 << PORTD7);
		  PORTD |= (1 << PORTD4)|(1 << PORTD6)|(1 << PORTD5)|(1 << PORTD2);

		}
	
		else if(layer == 1) {
		  PORTD = (0 << PORTD4);
		  PORTD |= (1 << PORTD2)|(1 << PORTD6)|(1 << PORTD5)|(1 << PORTD7);
		}
		
			  
		else if(layer == 2) {
		  PORTD = (0 << PORTD2);
		  PORTD |= (1 << PORTD4)|(1 << PORTD6)|(1 << PORTD5)|(1 << PORTD7);

		}
		
		else if(layer == 3) {
		  PORTD = (0 << PORTD5);
		  PORTD |= (1 << PORTD4)|(1 << PORTD6)|(1 << PORT2)|(1 << PORTD7);
		}


		else if(layer == 4) {
		  PORTD = (0 << PORTD6);
		  PORTD |= (1 << PORTD4)|(1 << PORTD2)|(1 << PORTD5)|(1 << PORTD7);
		}
		

		PORTB = (0 << PORTB2); //BLANK LOW
	
		
		/* cycle sets the speed of layer change. the interrupt is thrown every 4096 clock cycles,
		   which is every 256 us, so if cycle is set at 10, it moves to the next layer every 2.56 ms
		*/

		//increment duty cycle counter
		cycle++;
		//if ten cycles have gone by, then set flag for gsData update & reset cycle
	
		if(cycle > 10) {
		  layer++;
		  cycle = 0;
		}
		
		if(layer > 4){
		  gsDataUpdateFlag = 1;
		  layer = 0;
		}
}





void main() {

       //Setup ADC
       // AREF = AVcc
       ADMUX = (1<<REFS0);
  
       // ADC Enable and prescaler of 128
       // 16000000/128 = 125000
       ADCSRA = (1<<ADEN)|(1<<ADPS2)|(1<<ADPS1)|(1<<ADPS0);
       
       //THINGS TO SETUP FOR EYE!
       //change ADC pins- now have shift register on two pins
       //setup output pin on otherside (what port?)



	//Enable Output Compare A interrupt for timer0 every 4096 clock cycles	
	TCCR0A = (1 << WGM01); //Clear Timer on Compare
	TCCR0B = ((1 << CS02) | (1 << CS00)); // clk_io/1024 (From prescaler)	
	OCR0A = 3; //Generate an interrupt every 4096 clock cycles for GS data transmission
	TIMSK0 |= (1 << OCIE0A); //Enable Timer/Counter0 Compare Match A interrupt
       
	//Set output pins & initial levels
	DDRB |= (1 << DDB1)|(1 << DDB2)|(1 << DDB3)|(1 << DDB5); 
	//DDB1 is XLAT, DDB2 is BLANK, DDB3 is MOSI/SIN, DDB5 is SCK
	PORTB |= (1 << PORTB2)|(1 << PORTB3)|(1 << PORTB5); 

	//PB2 (BLANK) is effectively SS for TLC: low/active, high/inactive

	//Set output pins & pins high (mosfets off)
       	DDRD |= (1 << DDD2)|(1 << DDD4)|(1 << DDD5)|(1 << DDD6)|(1 << DDD7);
	PORTD |= (1 << PORTD2)|(1 << PORTD4)|(1 << PORTD5)|(1 << PORTD6)|(1 << PORTD7);


	//Set output pins for eye shift register
	DDRD |= (1 << DDD3);
	DDRC |= (1 << DDC0)|(1 << DDC5);


	//Enable SPI, Master, and set clock rate F_CPU/2
	SPCR = (1 << SPE) | (1 << MSTR);
	SPSR = (1 << SPI2X);
       
	//Start Display
	sei(); //Enable Global Interrupts
	PORTB = (0 << PORTB2); //BLANK low, TLC active
	



	
	
	//update cube & update gsdata
	while(1) {



	  if (gsDataUpdateFlag) {
	    Update_gsData();
	    Update_Columns();
	    Update_Cube();
	  }
	 
	}	

}






